# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

#%bcond_with test

# repolib definitions
%define repodirmvn %{_javadir}/repository.jboss.com/maven2-brew
%define repodir %{_javadir}/repository.jboss.com/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

#%define section free
%define reltag Final
%define namedversion %{version}.%{reltag}-redhat-1

Name:           ironjacamar
Version:        1.0.11
Release:        1.Final_redhat_1%{?dist}
Epoch:          0
Summary:        An implementation of the Java Connector Architecture 1.6 specification
License:        LGPLv2.1+
Group:          Development/Libraries/Java
URL:            http://www.jboss.org/ironjacamar/


# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-jca/tags/IRONJACAMAR_1_0_11_FINAL/ ironjacamar-1.0.11.Final
# Exported revision 112933.
# tar czf ironjacamar-1.0.11.Final.tar.gz ironjacamar-1.0.11.Final
Source0:        ironjacamar-%{version}.%{reltag}.tar.gz
Source1:        ironjacamar-component-info.xml
Source2:        ivy.settings.xml

Patch0:         ironjacamar-build.patch
Patch1:         ironjacamar-mvn-pom-template.patch

# common package definitions:
BuildArch:      noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

# Build Requires:
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant
BuildRequires:  maven2-plugin-deploy
BuildRequires:  apache-ivy = 0:2.2.0

BuildRequires:  dom4j
BuildRequires:  jdepend
BuildRequires:  jboss-logmanager
BuildRequires:  jboss-threads
BuildRequires:  hibernate-beanvalidation-api
BuildRequires:  jboss-transaction-spi
BuildRequires:  jboss-logging
BuildRequires:  jboss-logging-tools
BuildRequires:  picketbox
BuildRequires:  jboss-jaspi-api_1.0_spec
BuildRequires:  jboss-transaction-api_1.1_spec
BuildRequires:  jboss-parent
BuildRequires:  apiviz

# Requires:
Requires:       jboss-logging
Requires:       jboss-logmanager
Requires:       picketbox
Requires:       hibernate-beanvalidation-api
Requires:       jboss-threads
Requires:       jboss-jaspi-api_1.0_spec
Requires:       jboss-transaction-api_1.1_spec
Requires:       jboss-transaction-spi

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3


%description
An implementation of the Java Connector Architecture 1.6 specification

#
#  subpackage: ironjacamar-javadoc
#
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils >= 0:1.7.3

%description javadoc
Javadoc for ironjacamar

#
#  subpackage: ironjacamar-repolib
#
%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library
%endif

%prep
%setup -q -n %{name}-%{version}.%{reltag}

%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav0

# removes all binary files from sources
%{_bindir}/find . -name *.jar -exec rm -f {} +
%{_bindir}/find . -name *.zip -exec rm -f {} +

%{_bindir}/find . -name build.xml -exec sed -i "s/indexMetaInf=\"true\"//g" {} +
#%{_bindir}/find . -name build.xml -exec sed -i "s/doclet=\"org.jboss.apiviz.APIviz\"//g" {} +
#%{_bindir}/find . -name build.xml -exec sed -i "s/docletpathref=\"main.lib.path.id\"//g" {} +

cp %{SOURCE2} .

%build
%{_bindir}/ant -Das=true nexus

%install
rm -rf $RPM_BUILD_ROOT

# parent directory for jars, poms and javadocs, repolib
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodirmvn}

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}

tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}

install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{namedversion}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml

%endif

for artifactId in \
                  ironjacamar-spec-api \
                  ironjacamar-common-api \
                  ironjacamar-common-impl \
                  ironjacamar-common-spi \
                  ironjacamar-core-api \
                  ironjacamar-core-impl \
                  ironjacamar-deployers-common \
                  ironjacamar-jdbc \
                  ironjacamar-validator \
               ; do

# jars
install -m 644 target/${artifactId}.jar $RPM_BUILD_ROOT%{_javadir}/${artifactId}-%{namedversion}.jar
install -m 644 target/${artifactId}-sources.jar $RPM_BUILD_ROOT%{_javadir}/${artifactId}-sources-%{namedversion}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{namedversion}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

# poms
%add_to_maven_depmap org.jboss.ironjacamar ${artifactId} %{namedversion} JPP ${artifactId}
install -m 644 target/${artifactId}.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-${artifactId}.pom

sed -i "s/<version>.*[^r][^e][^d][^h][^a][^t][^-][^1]<\/version>//g" $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-${artifactId}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}/${artifactId}-%{version}
unzip -d $RPM_BUILD_ROOT%{_javadocdir}/%{name}/${artifactId}-%{version} target/${artifactId}-javadoc.jar
rm -rf $RPM_BUILD_ROOT%{_javadocdir}/%{name}/${artifactId}-%{version}/META-INF
(cd $RPM_BUILD_ROOT%{_javadocdir}/%{name} && ln -s ${artifactId}-%{version} ${artifactId})


# repolib
%if %with repolib
install -p -m 644 $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-${artifactId}.pom $RPM_BUILD_ROOT%{repodirlib}/${artifactId}.pom
install -p -m 644 $RPM_BUILD_ROOT%{_javadir}/${artifactId}-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/${artifactId}.jar
install -p -m 644 $RPM_BUILD_ROOT%{_javadir}/${artifactId}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/${artifactId}-sources.jar
install -p -m 644 target/${artifactId}-javadoc.jar $RPM_BUILD_ROOT%{repodirlib}/${artifactId}-javadoc.jar

# deploy to maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -DpomFile=$RPM_BUILD_ROOT%{repodirlib}/${artifactId}.pom -Dfile=$RPM_BUILD_ROOT%{repodirlib}/${artifactId}.jar -Durl=file:$RPM_BUILD_ROOT%{repodirmvn} -Dversion=%{namedversion}
%{_bindir}/mvn-jpp deploy:deploy-file -DpomFile=$RPM_BUILD_ROOT%{repodirlib}/${artifactId}.pom -Dfile=$RPM_BUILD_ROOT%{repodirlib}/${artifactId}-sources.jar -Dclassifier=sources -Durl=file:$RPM_BUILD_ROOT%{repodirmvn} -Dversion=%{namedversion}
%{_bindir}/mvn-jpp deploy:deploy-file -DpomFile=$RPM_BUILD_ROOT%{repodirlib}/${artifactId}.pom -Dfile=$RPM_BUILD_ROOT%{repodirlib}/${artifactId}-javadoc.jar -Dclassifier=javadoc -Durl=file:$RPM_BUILD_ROOT%{repodirmvn} -Dversion=%{namedversion}

%endif

done

%clean
rm -rf $RPM_BUILD_ROOT
                                                                                                     
%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/*jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com

%endif

%changelog
* Mon May 07 2012 Lin Gao <lgao@redhat.com> - 0:1.0.11-1.Final_redhat_1
- Upgrade to 1.0.11.Final

* Wed May 02 2012 Lin Gao <lgao@redhat.com> - 0:1.0.10-1.Final_redhat_1
- Upgrade to 1.0.10.Final
- Add Requires components
- Build javadoc using apiviz

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.9-2.Final_redhat_1.1
- Rebuild using cache signing

* Thu Mar 22 2012 Lin Gao <lgao@redhat.com> - 0:1.0.9-2.Final_redhat_1
- change jars install path
- add ironjacamar-spec-api to component-info.xml in repolib
- fix release tag

* Mon Mar 12 2012 Lin Gao <lgao@redhat.com> - 0:1.0.9-1_redhat_1
- upgrade to 1.0.9.Final

* Mon Mar 05 2012 Lin Gao <lgao@redhat.com> - 0:1.0.8-2_redhat_1
- remove version of BR jboss-logging-tools

* Mon Mar 05 2012 Lin Gao <lgao@redhat.com> - 0:1.0.8-1_redhat_1
- upgrade to 1.0.8.Final
- remove META-INF from javadoc
- Requires jpackage-utils in javadoc subpackage

* Tue Jan 17 2012 Lin Gao <lgao@redhat.com> - 0:1.0.7-1_redhat_1
- upgrade to 1.0.7.Final

* Thu Jan 05 2012 Lin Gao <lgao@redhat.com> - 0:1.0.6-1_redhat_1
- upgrade to 1.0.6.Final
- using BOMs in pom
- fix JPP mapping

* Thu Oct 27 2011 Lin Gao <lgao@redhat.com> - 0:1.0.5-1_redhat_1
- upgrade to 1.0.5.Final

* Tue Sep 20 2011 Lin Gao <lgao@redhat.com> - 0:1.0.3-1_redhat_1
- upgrade to 1.0.3.Final
- wolf build phrase

* Mon Jul 25 2011 Lin Gao <lgao@redhat.com> - 0:1.0.1-1
- upgrade to 1.0.1.Final

* Sat Jul 9 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-8
- use jboss-logging-tools 1.0.0.Beta7 to fix jar differs from upstream jar

* Fri Jul 8 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-7
- fix jar differs from upstream jar

* Fri Jul 8 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-6
- fix strange groupId in pom files

* Fri Jul 1 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-5
- put -javadoc.jar to repolib

* Mon Jun 13 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-4
- patch build scripts to build EAP components only
- make ivy.setting.xml to use local repo only
- use jboss-logging-mead and picketbox-mead package

* Thu Jun 9 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-3
- fix description of each packages

* Wed Jun 8 2011 Lin Gao <lgao@redhat.com> - 0:1.0.0-2
- Initial spec version
- use ironjacamar 1.0.0.Beta6.1

* Tue May 24 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.0.0-1
- Placeholder
